// FILE: CSRTS2.CPP
// MODULE: GET_NUMBERS
// PROGRAM: CSRTS
////////////////////////////////////////////////////////////////////////////////
//
//     Functions:
//
//             get_field()     extracts the field number and width from the passed
//                             command tail argument
//
//             read_field()    extracts just the field number
//
//
////////////////////////////////////////////////////////////////////////////////


#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>


char c_2_notice[] = " Copyright 1991, Ted Davis\
                   Sort routine after Comb Sort,\
                   Copyright 1991, McGraw-Hill";
extern char string[82];                // a general purpose string variable.
extern char * str;                     // a pointer used mostly to shorten strings.
extern int flag;                       // the go-no-go flag.
extern int i, k, l, j;                 // general use integer variables
extern char * p;                       // another string pointer like str.
extern int field_i;
extern int fields_widths[];
extern int fields_decimal[];
extern int field_0;
extern int numbers[];

extern void print_copyright_err(void);

int get_field(char * args, int * field_, int _i);
int read_field(int * field_, int _i);


int get_field(char * args, int *field_, int _i)
// Extracts a field number and a field width (if present) from the passed command
// tail argument.  Returns a corrected index that it was passed.
{
int z = 0;
    if(field_i < 7)
    {
        p = strchr(args, '.');
        if(p)
        {
            j = p - args;
            args[j] = ' ';
            p = strchr(args, '.');
            if(p)
            {
                j = p - args;
                args[j] = ' ';
            }
            str = args + 2;
            sscanf(str, "%i%i%i", &k, &j, &z);
            field_[++_i] = abs(k) - 1;
            fields_widths[_i] = abs(j);
            fields_decimal[_i] = abs(z);
            if(!k) {field_0 = -1;}
        }
        else
        {
            str = args + 2;
            _i = read_field(field_, _i);
            if(!k) {field_0 = -1;}
            }
            if(k == 0)
            {
                print_copyright_err();
                cerr << "\nFATAL ERROR: DEFECTIVE ARGUMENT - " << args << "\n";
                flag = -1;
            }
    }
    else
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: TOO MANY FIELD NUMBER ARGUMENTS - " << args << "\n";
        flag = -1;
    }
    if((numbers[1] != -1))
    {
        field_i = -1;
        print_copyright_err();
        cerr << "\nWARNING: FIELD NUMBER CONFLICTS WITH COLUMN ARGUMENT, "<< args <<" IGNORED\n";
    }
    if(numbers[2] != -1)
    {
        field_i = -1;
        print_copyright_err();
        cerr << "\nWARNING: FIELD NUMBER CONFLICTS WITH FIELD WIDTH, "<< args <<" IGNORED\n";
    }
    if(field_i && !k)
    {
        print_copyright_err();
        cerr << "\nWARNING: FIELD NUMBER 0 CONFLICTS WITH OTHER FIELD, "<< args <<" IGNORED\n";
        field_i--;
    }
    if(k && field_0)
    {
        print_copyright_err();
        cerr << "\nWARNING: FIELD NUMBER CONFLICTS WITH FIELD 0, "<< args <<" IGNORED\n";
        field_i--;
    }
    return(_i);
}

int read_field(int *field_, int _i)
// Extracts a field number from the prepared global variable str. Returns an 
// updated index that it was passed.
{
    sscanf(str, "%i", &k);
    if(k)
    {
        field_[++_i] = abs(k) - 1;
    }
    else
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: DEFECTIVE FIELD NUMBER ARGUMENT - " << str << "\n";
    }
    return(_i);
}

