// FILE: CSRTS3.CPP
// MODULE: SORTER
// PROGRAM: CSRTS
////////////////////////////////////////////////////////////////////////////////
//
//     Function:
//             DoubleCombSort()        the actual sort routine
//
//
////////////////////////////////////////////////////////////////////////////////

#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>


#define max_string_len 134
#define ShrinkFactor 1.3


char c_3_notice[] = " Copyright 1991, Ted Davis\
                   Sort routine after Comb Sort,\
                   Copyright 1991, McGraw-Hill";


void DoubleCombSort(long size, int direction, char * huge * index);


void DoubleCombSort(long size, int direction, char * huge * index)
// Sorts one array, on the basis of another (that is derived from it), using
// the Combsort algorithm from Byte magazine, Vol 16, # 4, as modified here.
// SEE the article on page 315 for an explanation of how the algorithm works
// and a discussion of its merits.  I think five of the lines are from the magazine.
// * It should be emphasized that the strings are in a block of memory that is allocated
// * as an array, but are not in the fixed length format usual in C.  The strings are
// * packed into the space and the "arrays" are simulated by an actual array of
// * huge pointers into the storage space.  Even number index entries are to the
// * source strings and odd entries are to the sort patterns.  The code compares the
// * pattern strings and sorts the INDEX array, which, when the array is read out
// * in order by even numbers, produces the effect of having sorted the strings.
{
long switches, i, j, k, top, gap, x ;
char huge *hold;

    size /= 2;  // there are only half as many strings as entries
    gap = size;
    do
    {
        gap = (long)((float)gap/ShrinkFactor);  // * the original code had a switch here,
        if(gap == 0)                            // * but switch cannot deal with the longs
        {                                       // * required to manipulate the huge array.
            gap = 1;
        }
        else
        {
            if((gap == 9) || (gap == 10))
            {
                gap = 11;
            }
        }
        switches = 0;
        top = size - gap;
        for(i = 0; i < (top); i++)
        {
            j = i + gap;
            k = i + i + 1; j += (j + 1);        // use odd numbers only (patterns).
            if(!direction)                      // normal sort.
            {
                if(strcmp(index[k], index[j]) > 0)
                    // * string comparison, greater than.
                {                               // * double pointer swap.
                    hold = index[k];   // * swap sort pattern pointers.
                    index[k] = index[j];
                    index[j] = hold;
                    k--; j--;
                    // * string pointers are in preceding even locations.
                    hold = index[k]; // * swap string pointers.
                    index[k] = index[j];
                    index[j] = hold;
                    switches++;
                }
            }
            else                                // reverse sort.
            {
                if(strcmp(index[k], index[j]) < 0)
                    // * string comparison, less than.
                {                               // * double pointer swap.
                    hold = index[k];   // * swap sort pattern pointers.
                    index[k] = index[j];
                    index[j] = hold;
                    k--; j--;
                    hold = index[k]; // * swap string pointers.
                    index[k] = index[j];
                    index[j] = hold;
                    switches++;
                }
            }
        }
    } while (switches || (gap > 1));
}

