// FILE: CSRTS5.CPP
// MODULE: TIME_CONVERT
// PROGRAM: CSRTS
////////////////////////////////////////////////////////////////////////////////
//
//     Function:
//             time_convert()          converts times in AM/PM format to 24 hr.
//
//
////////////////////////////////////////////////////////////////////////////////

#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>

char c_5_notice[] = " Copyright 1991, Ted Davis\
                   Sort routine after Comb Sort,\
                   Copyright 1991, McGraw-Hill";



void time_convert(char *string, char *extra);



void time_convert(char *string, char *extra)
// converts am/pm times to 24 hr for correct sorting.  AM/PM, if present, will
// be in the main field or the one following it,depending on whether it is separated
// from the numbers by a space or not.
{
int a_p = -1;
int h = -1, m = -1, s = -1;
int i;
char str[10];
char t[4];
char * st;
     // first find the am/pm indication
     if(strchr(string, 'p') || strchr(string, 'P'))
     {
        a_p = 1;
     }
     else
     {
        if(strchr(string, 'a') || strchr(string, 'A'))
        {
            a_p = 0;
        }
        else    // not in first given field, look in next one (first character)
        {
            if((extra[0] == 'p') || (extra[0] == 'P'))
            {
                a_p = 1;
            }
            else
            {
                if((extra[0] == 'a') || (extra[0] == 'A'))
                {
                    a_p = 0;
                }   // else there is no am or pm, routine cannot work
            }
        }
     }
     // parse the time field into hours, minutes, seconds
     st = strchr(string, ':');          // find first colon
     if(st != NULL)
     {
        i = st - string;                // index it
        string[i] = ' ';                // replace it with a space, making hours a separate field
        st = strchr(string, ':');       // find second colon
        if(st != NULL)                  // if there was one
        {
            i = st - string;            // index minutes/seconds separator, if any
            string[i] = ' ';            // replace it with a space, now three fields: hr, min, sec
        }
        // convert to numbers
        sscanf(string, "%i%i%i", &h, &m, &s);
     }  // else already in proper format (no delimiters)
     if((a_p != -1) && (h != -1) && (m != -1))
     {
        if(a_p) // if pm
        {
            if(h != 12)
            {
                h += 12;
            }
        }
        else    // am
        {
            if(h == 12)
            {
                h = 0;
            }
        }
        itoa(h, t, 10);                 // convert hours to string
        if(h < 10)                      // normalize to exactly two digits
        {
            strcpy(string, "0");
            strcat(string, t);
        }
        else                            // already two digits
        {
            strcpy(string, t);          // start new time string
        }
        itoa(m, t, 10);                 // convert minutes to string
        if(m < 10)                      // normalize to exactly two digits
        {
            strcpy(str, "0");
            strcat(str, t);
        }
        else
        {
            strcpy(str, t);
        }
        strcat(string, str);            // add to new time string
        if(s != -1)                     // test for seconds
        {                               // do the same things for seconds, if they exist
            itoa(s, t, 10);
            if(s < 10)
            {
                strcpy(str, "0");
                strcat(str, t);
            }
            else
            {
                strcpy(str, t);
            }
            strcat(string, str);
        }
        else            // if no seconds in time string, make some up (00)
        {
            strcat(string, "00");
        }
     }
}

