echo off
type demo1.dat
echo .
pause
echo No.1 Sort the above directory listing using all defaults.
echo Note that it is identical to the DOS SORT.
echo "csrts < demo1.dat"
pause
cls
csrts < demo1.dat
pause
cls
echo No.2 Sort the directory listing by file size as numbers, smallest first.
echo This too is identical to the output from SORT /+13.
echo "csrts /N3.8 < demo1.dat"
pause
cls
csrts /N3.8 < demo1.dat
pause
cls
echo No.3 Sort the directory listing by file size as numbers, largest first.
echo Again, SORT /r /+13 does the same thing.
echo "csrts /n3.8 /R < demo1.dat"
pause
cls
csrts /n3.8 /R < demo1.dat
pause
cls
echo No.4 Sort the directory listing by file date, time, size; latest, largest first.
echo We have left SORT behind; it cannot even attempt any more with this file.
echo "csrts /d4 /T5 /n3.7 /r4 /r3 /r5 < demo1.dat"
pause
cls
csrts /d4 /T5 /n3.7 /r4 /r3 /r5 < demo1.dat
pause
cls
echo No.5 Sort the directory listing by date, reverse sort duplicates by
echo extension, duplicate extensions normally by name.  Note that fields
echo four and two are constant width.  Dates do not get special "date" treatment.
echo "csrts /$4.10 /$2.3 /$1 /R2 < demo1.dat"
pause
cls
csrts /$4.10 /$2.3 /$1 /R2 < demo1.dat
pause
cls
echo No.6 Reverse sort by date then extension, then normal sort by name.
echo Note that fields one and two are NOT constant width, the BOX.B line is
echo therefore out of place in the sort.
echo "csrts /$4.10 /$2 /$1 /R2 /r4 < demo1.dat"
pause
cls
csrts /$4.10 /$2 /$1 /R2 /r4 < demo1.dat
pause
cls
type demo2.dat
echo .
echo No.7 Default sort the table. (Almost identical to SORT.)
echo The Combsort algorithm encounters the fields in a different order from
echo the order SORT does - the equal fields are not necessarily in the same order
echo It should be noted that the lines that are in different places are case
echo insensitive equivalents and sort as identical.  They wind up together,
echo but not necessarily in the same order.
echo "csrts < demo2.dat"
pause
cls
csrts < demo2.dat
pause
cls
echo No. 8 Sort with defaults except that column 1 is case sensitive.
echo SORT cannot do this or the remaining demo2.dat sorts.
echo "csrts /$1.8 /$2.8 /$3.8 /$4.8 /c1 < demo2.dat"
pause
cls
csrts /$1.8 /$2.8 /$3.8 /$4.8 /c1 < demo2.dat
pause
cls
echo No.9 Sort tables as if the fields were in the order 4 3 2 1.
echo Treat the number fields as decimal numbers.  Case insensitive sort.
echo "csrts /n4.7.4 /$3.8 /N2.4.4 /$1 < demo2.dat"
pause
cls
csrts /n4.7.4 /$3.8 /N2.4.4 /$1 < demo2.dat
pause
cls
echo No.10 Normal sort field 1, then reverse sort column 2 then 4 as numbers
echo Note the double reverse sort
echo "csrts /r /R1 /$1.10 /n2.5.4 /n4.5 < demo2.dat"
pause
cls
csrts /r /R1 /$1.10 /n2.5.4 /n4.5 < demo2.dat
pause
cls
echo No.11 Normal sort the number fields 2 and 4, then reverse sort the
echo word fields 3 and 1.
echo "csrts /n2.6.4 /n4.7.4 /$3.10 /$1 /R3 /r1 < demo2.dat"
pause
cls
csrts /n2.6.4 /n4.7.4 /$3.10 /$1 /R3 /r1 < demo2.dat
pause
cls
type demo3.dat
echo No.12 Sort dates as strings.  Note that the years 9 and 193 always sort wrong.
echo They are outside the specified range of the date converter and are included to
echo show the effect of defective data.  Note that this is the only date sort
echo that SORT can even attempt.  This one is identical to the DOS SORT.
echo "csrts < demo3.dat"
pause
cls
csrts < demo3.dat
pause
cls
echo No.13 Sort dates as numbers. Note the effect the delimiters have.
echo This is included to show the importance of proper field type selection.
echo There is no SORT equivalent.
echo "csrts /n1.8 < demo3.dat"
pause
cls
csrts /n1.8 < demo3.dat
pause
cls
echo No.14 Sort dates as dates. SORT cannot deal with dates as dates.
echo "csrts /d1 < demo3.dat"
pause
cls
csrts /d1 < demo3.dat
pause
cls
echo No.15 Reverse sort as dates.
echo "csrts /d1 /r < demo3.dat"
pause
cls
csrts /d1 /r < demo3.dat
pause
cls
echo No.16 Normal sort as European dates.
echo "csrts /d-1 < demo3.dat"
pause
cls
csrts /d-1 < demo3.dat
pause
cls
echo No.17 Reverse sort as European dates.
echo "csrts /d-1 /R < demo3.dat"
pause
cls
csrts /d-1 /R < demo3.dat
pause
cls
echo That ends the CSRTS demo.  The screen will clear when the batch file exits.
pause
cls

